<template>
<st-content heading="Alumnos">
<st-student-bulk-register v-model="bulkDialog" @refreshData="refreshData" @cancel="closeBulkModal" :key="'bulk'+bulkComponentKey"/>
<st-student-register v-model="dialog" @refreshData="refreshData" :key="componentKey"></st-student-register>
  <div>
    <div class="content-body">
      <div class="table-heading">
        <st-search text="Buscar por nombre de código" @enter="search($event)"/>
        <div>
          <st-primary-btn nombre="Registrar Alumno" @click="open"/>
          <st-bulk-load-button class="ml-2" @click="openBulkModal"/>
        </div>
      </div>
      <div class="table-heading">
      <v-label>Solo se muestran a lo más 10 resultados</v-label>
    </div>
      <st-data-table
        :dataInfo = "{ headers,items }"
        :dataPath = "path"
        :loading = "loading"
      />
    </div>
  </div>
</st-content>
</template>

<script>
import DataTable from '@/components/DataTable'
import Search from '@/components/Search'
import StudentRegister from '@/components/student/RegisterStudent'
import BulkLoadButton from '../../../components/BulkLoadButton'
import StudentBulkRegister from "../../../components/StudentBulkRegister";

export default {
  components:{
    'st-data-table': DataTable,
    'st-search': Search,
    'st-student-register': StudentRegister,
    'st-bulk-load-button': BulkLoadButton,
    'st-student-bulk-register': StudentBulkRegister,
  },
  mounted(){
    this.search('')
  },
  data () {
    return{
      items: [],
      dialog:false,
      bulkDialog: false,
      loading:false,
      path:{
        url: '/coordinador/alumnos/',
        id: 'idAlumno'
      },
      headers: [
      {
        text: 'Nombre',
        align: 'start',
        value: 'nombres',
      },
      {
        text: 'Código',
        value: 'codigo'
      },
      {
        text: 'Unidad',
        value: 'nombreUnidad'
      }
      ],
      componentKey: 0,
      bulkComponentKey: 0,
    }
  },
  methods:{
    async search(value){
      this.loading = true
      try{
        const idUnit = this.$store.state.role.idUnit;
        let { data: { data } } = await this.$api.getStudentsByUnit(idUnit,value)
        this.items = data
      } catch (e){
        this.$store.commit('setError', e)
      }
        this.loading = false
    },
    refreshData(response) {
      this.dialog=false;
      this.bulkDialog=false
      this.search('');
    },
    open() {
      this.dialog=true;
      this.componentKey += 1; //forceRerender
    },
    openBulkModal() {
      this.bulkDialog = true;
      this.bulkComponentKey += 1;
    },
    closeBulkModal() {
      this.bulkDialog = false;
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
